summaryrefslogtreecommitdiffstats
path: root/bin
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2017-04-08 10:27:26 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2017-04-08 10:58:47 +0000
commitc1abaace560accadf985684411357e9387c144c0 (patch)
tree6eba1363e3c874f452fd981ba9264f13b869a17d /bin
parentInitial commit. (diff)
downloadopen-infrastructure-storage-tools-c1abaace560accadf985684411357e9387c144c0.tar.xz
open-infrastructure-storage-tools-c1abaace560accadf985684411357e9387c144c0.zip
Adding upstream version 20170405.upstream/20170405
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'bin')
-rwxr-xr-xbin/ceph-info50
-rwxr-xr-xbin/ceph-log40
-rwxr-xr-xbin/ceph-remove-osd67
-rwxr-xr-xbin/cephfs-snap88
4 files changed, 245 insertions, 0 deletions
diff --git a/bin/ceph-info b/bin/ceph-info
new file mode 100755
index 0000000..4a504b2
--- /dev/null
+++ b/bin/ceph-info
@@ -0,0 +1,50 @@
+#!/bin/sh
+
+# storage-tools - Additional utilities to manage storage related tasks
+# Copyright (C) 2014-2017 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+SOFTWARE="storage-tools"
+PROGRAM="ceph-info"
+
+if [ -e "/etc/default/${SOFTWARE}" ]
+then
+ . "/etc/default/${SOFTWARE}"
+fi
+
+case "${CEPH_INFO}" in
+ true)
+ ;;
+
+ *)
+ exit 0
+ ;;
+esac
+
+DATE="$(date -R)"
+HOST="$(hostname -f)"
+
+mkdir -p "/var/log/${SOFTWARE}/${PROGRAM}"
+
+for INFORMATION in ceph-status ceph-df ceph-osd-df ceph-osd-tree ceph-version
+do
+ COMMAND="$(echo ${INFORMATION} | sed -e 's|-| |g')"
+
+ ${COMMAND} > "/var/log/${SOFTWARE}/${PROGRAM}/${INFORMATION}.txt"
+done
+
+echo " -- ${HOST} ${DATE}" > "/var/log/${SOFTWARE}/${PROGRAM}/date.txt"
diff --git a/bin/ceph-log b/bin/ceph-log
new file mode 100755
index 0000000..f06605f
--- /dev/null
+++ b/bin/ceph-log
@@ -0,0 +1,40 @@
+#!/bin/sh
+
+# storage-tools - Additional utilities to manage storage related tasks
+# Copyright (C) 2014-2017 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+SOFTWARE="storage-tools"
+PROGRAM="ceph-log"
+
+if [ -e "/etc/default/${SOFTWARE}" ]
+then
+ . "/etc/default/${SOFTWARE}"
+fi
+
+case "${CEPH_LOG}" in
+ true)
+ ;;
+
+ *)
+ exit 0
+ ;;
+esac
+
+mkdir -p "/var/log/${SOFTWARE}/${PROGRAM}"
+
+ceph --watch >> "/var/log/${SOFTWARE}/${PROGRAM}/ceph-watch.log"
diff --git a/bin/ceph-remove-osd b/bin/ceph-remove-osd
new file mode 100755
index 0000000..8c0f38a
--- /dev/null
+++ b/bin/ceph-remove-osd
@@ -0,0 +1,67 @@
+#!/bin/sh
+
+# storage-tools - Additional utilities to manage storage related tasks
+# Copyright (C) 2014-2017 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+PROGRAM="$(basename ${0})"
+
+OSDS="${@}"
+
+Usage ()
+{
+ echo "Usage: ${PROGRAM} OSD1 OSD2.. OSDn"
+ exit 1
+}
+
+if [ -z "${OSDS}" ]
+then
+ Usage
+fi
+
+if [ ! -x /usr/bin/jq ]
+then
+ echo "'${PROGRAM}': /usr/bin/jp - no such file." >&2
+ exit 1
+fi
+
+# Run
+for OSD in ${OSDS}
+do
+ HOST="$(ceph osd find ${OSD} | jq -r '.["crush_location"]["host"]')"
+
+ # remove the failed OSD
+ ceph osd out ${OSD}
+
+ # stop the osd.${OSD} daemon on the respective storage host
+ ssh ceph-deploy@${HOST} sudo service ceph-osd@${OSD} stop
+
+ # unmount the disk
+ ssh ceph-deploy@${HOST} sudo umount /var/lib/ceph/osd/ceph-${OSD}
+
+ # remove osd from crush map
+ ceph osd crush remove osd.${OSD}
+
+ # remove cephx key
+ ceph auth del osd.${OSD}
+
+ # mark osd as down
+ ceph osd down osd.${OSD}
+
+ # remove the osd
+ ceph osd rm osd.${OSD}
+done
diff --git a/bin/cephfs-snap b/bin/cephfs-snap
new file mode 100755
index 0000000..d846ef4
--- /dev/null
+++ b/bin/cephfs-snap
@@ -0,0 +1,88 @@
+#!/bin/sh
+
+# storage-tools - Additional utilities to manage storage related tasks
+# Copyright (C) 2014-2017 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+SOFTWARE="storage-tools"
+PROGRAM="cephfs-snap"
+
+ACTION="${1}"
+
+Usage ()
+{
+ echo "Usage: ${PROGRAM} {hourly|daily|weekly|hourly}" >&2
+ exit 1
+}
+
+if [ -e "/etc/default/${SOFTWARE}" ]
+then
+ . "/etc/default/${SOFTWARE}"
+fi
+
+case "${CEPHFS_SNAP}" in
+ true)
+ ;;
+
+ *)
+ exit 0
+ ;;
+esac
+
+if [ -z "${CEPHFS_DIRECTORIES}" ]
+then
+ echo "E: no cephfs directories defined in /etc/default/${SOFTWARE}" >&2
+ exit 1
+fi
+
+case "${ACTION}" in
+ hourly|daily|weekly|monthly)
+
+ ;;
+
+ *)
+ Usage
+ ;;
+esac
+
+# Run
+DATE="$(date +%Y-%m-%d\ %H:%M:%S)"
+HOST="$(hostname -f)"
+
+TIME="$(date +%Y-%m-%d_%H%M%z)"
+SNAPSHOT="${ACTION}_${TIME}"
+
+# logfile
+echo "${DATE} ${HOST} ${PROGRAM} creating ${ACTION} snapshots" >> "/var/log/${SOFTWARE}/${PROGRAM}.log"
+
+# irc
+if [ -e /usr/bin/irk ] && [ -e "/etc/default/${SOFTWARE}" ]
+then
+ if [ -n "${IRK_TARGETS}" ]
+ then
+ for TARGET in ${IRK_TARGETS}
+ do
+ irk ${TARGET} "\x0312${HOST}:\x03 \x0303${PROGRAM}\x03 creating \x0307${ACTION}\x03 snapshots"
+ done
+ fi
+fi
+
+for CEPHFS_DIRECTORY in ${CEPHFS_DIRECTORIES}
+do
+ cd "${CEPHFS_DIRECTORY}"/.snap
+ mkdir "${SNAPSHOT}"
+done